#!/bin/bash
#Check if uptime less than 10 minutes then exit
upSeconds="$(cat /proc/uptime | grep -o '^[0-9]\+')"
upMins=$((${upSeconds} / 60))
if [ "${upMins}" -lt "10" ];then
    echo "uptime is ${upMins}"
    exit 0
fi

CONFIG_DIR="/etc/cron.random"
ls $CONFIG_DIR|while read -r file;do
	TASK_NAME="$file"
	NEXT_RUN_DATE_FOLDER="/var/spool/RandomCronTasks"
	FROM_HOUR=2
	TO_HOUR=6
	source $CONFIG_DIR/$TASK_NAME
	NEXT_RUN_DATE_FILE="$NEXT_RUN_DATE_FOLDER/$TASK_NAME"
	LOCKFILE="/var/lock/$TASK_NAME.lock"

function isNeedRun(){
    if [ -f $NEXT_RUN_DATE_FILE ];
    then
        source $NEXT_RUN_DATE_FILE;

        local now=`date +%s`

        if [ "$now" -ge "$NEXT_RUN_DATE" ];
		then
			echo "true"
		else
		    echo "false"
        fi
    else
    	local nowHours=$((10#`date +%H`))
		if [ "$nowHours" -ge "$FROM_HOUR" ] && [ "$nowHours" -le "$TO_HOUR" ];
		then
		    echo "true"
		else
		    echo "false"
		fi
    fi
}

function setNextRunDate() {
    local now=`date +%s`
	local secondsTo=$(($TO_HOUR * 60 * 60))
	local secondsFrom=$(($FROM_HOUR *60 * 60))

	local randomSeconds=`shuf -i $secondsFrom-$secondsTo -n1`

    local tomorowDate=`date --date="next day" +"%Y/%m/%d"`
    local tomorowSeconds=`date -d "$tomorowDate" "+%s"`
    local remainingSeconds=$(($tomorowSeconds-$now))

    local nextRunDate=$(($now + $remainingSeconds + $randomSeconds))

    #echo "`date +"%Y/%m/%d %H:%M:%S" -d @$nextRunDate`"

    if [ ! -d "$NEXT_RUN_DATE_FOLDER" ]; then
		mkdir -p $NEXT_RUN_DATE_FOLDER -m 0777
	fi

    echo "NEXT_RUN_DATE=$nextRunDate" > $NEXT_RUN_DATE_FILE
	chmod 0666 $NEXT_RUN_DATE_FILE
}


if [ "$(isNeedRun)" == "true" ];
then
    if [ ! -f $LOCKFILE ];then
    	touch $LOCKFILE
    	echo Run the command \"$COMMAND\"
    	/bin/bash -c "$COMMAND"
    	$(setNextRunDate)
    	rm -rf $LOCKFILE
    else
	echo "$LOCKFILE exist"
    fi
else
    echo "Do not need to run the command \"$COMMAND\""
fi
done
