window.localStorage.setItem("auth", 0);
window.localStorage.setItem("auth", 0); // hak ie11

$(document).ready(function() {
	$("#u").focus();
	$('.google-sign-on').on('click', loadGoogleSignOnUrl);
	$('.office365-sign-on').on('click', loadOffice365SignOnUrl);
	isRememberAllowed();
});

function auth(isTwoFactor) {
	isTwoFactor

	var data = {
			remember: +$("#remember").is(':checked')
	}

	var error = false;

	if(isTwoFactor){
		data['type'] = 'next';
		data['code'] = $("#code").val();
		if(data['code'] == ''){
			$("#code").addClass('error');
			error = true;
		}
	}else{
		data['login'] = $("#u").val();
		data['password'] = $("#p").val();

		if(data['login'] == ''){
			$("#u").addClass('error');
			error = true;
		}

		if(data['password'] == ''){
			$("#p").addClass('error');
			error = true;
		}
	}

	if(error){
		return false;
	}

	sendLoginRequest(data);

	return false;
}

function showTwoFactorForm(){
	$('form.authForm').hide();
	$('form.twoFactorForm').show();
	$("#code").focus();
}

function sendLoginRequest(data){
	$('.box input.error').removeClass('error');

	$('.box').mask('Loading...');

	$.ajax({
		type: 'POST',
		url: '../api/v1/personal/login',
		data: data,
		success: function(data, textStatus, jqXHR){
			$('#error').html("");
			if(data && data.type == 'result' ){
				if(data.result == 'OK'){
					window.location = location.search.replace(/^\?/, '..') ? location.search.replace(/^\?/, '..') : '../';
				}else if(data.result['next']){
					$('.box').unmask();
					showTwoFactorForm();
				}
			}

		},
		error: function(jqXHR, textStatus, errorThrown){
			$('.box').unmask();
			var response = JSON.parse(jqXHR.responseText);
			if(response.type == 'error' && response.reason && response.reason!=''){
				$('#error').html(response.reason);
			}
		},
		complete: function(jqXHR, textStatus){

		}
	});
}

function callbackGoogleSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('#error').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#u").val(data.userInfo.email);
			$("#p").val('');

			var login = $("#u").val();

			var error = false;
			if(login == ''){
				$("#u").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'google',
				login: login,
				remember: +$("#remember").is(':checked'),
				token: data.token
			});
		}
	}
}


function callbackMicrosoftSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('#error').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#u").val(data.userInfo.preferred_username);
			$("#p").val('');

			var login = $("#u").val();

			var error = false;
			if(login == ''){
				$("#u").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'microsoft',
				login: login,
				remember: +$("#remember").is(':checked'),
				token: data.token
			});
		}
	}
}

function loadOffice365SignOnUrl(){
	window.open(
			'../api/Microsoft/SingleSignOn/?callback=callbackMicrosoftSingleSignOn',
			"Windows sing on",
			"location=0,status=0,scrollbars=0,width=800,height=500"
			);
}

function loadGoogleSignOnUrl(){
	window.open(
			'../api/Google/SingleSignOn/?callback=callbackGoogleSingleSignOn',
			"Google sing on",
			"location=0,status=0,scrollbars=0,width=800,height=500"
			);
}

function isRememberAllowed(){
	if(location.protocol !== 'https:'){
		$('#remember').attr('disabled', true);
	}
}